# Generated by Django 5.1.2 on 2024-10-24 18:17

import datetime
import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Event",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "type",
                    models.CharField(
                        choices=[
                            ("Apply", "Limit Applied on a Target"),
                            ("Eval", "Policies Evaluated"),
                        ],
                        max_length=255,
                    ),
                ),
                ("timestamp", models.DateTimeField(auto_now=True)),
                ("data", models.JSONField()),
            ],
        ),
        migrations.CreateModel(
            name="Policy",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_base_policy", models.BooleanField(default=False, editable=False)),
                ("name", models.CharField(max_length=255, unique=True)),
                ("domain", models.CharField(max_length=1024)),
                (
                    "lookback",
                    models.DurationField(default=datetime.timedelta(seconds=900)),
                ),
                ("description", models.TextField(blank=True, max_length=1024)),
                ("penalty_constraints", models.JSONField()),
                (
                    "penalty_duration",
                    models.DurationField(
                        default=datetime.timedelta(seconds=900), null=True
                    ),
                ),
                ("repeated_offense_scalar", models.FloatField(default=1.0, null=True)),
                (
                    "repeated_offense_lookback",
                    models.DurationField(
                        default=datetime.timedelta(seconds=10800), null=True
                    ),
                ),
                (
                    "grace_period",
                    models.DurationField(
                        default=datetime.timedelta(seconds=300), null=True
                    ),
                ),
                ("query_data", models.JSONField()),
            ],
            options={
                "verbose_name_plural": "Policies",
            },
        ),
        migrations.CreateModel(
            name="BasePolicy",
            fields=[],
            options={
                "proxy": True,
                "indexes": [],
                "constraints": [],
            },
            bases=("arbiter.policy",),
        ),
        migrations.CreateModel(
            name="UsagePolicy",
            fields=[],
            options={
                "proxy": True,
                "indexes": [],
                "constraints": [],
            },
            bases=("arbiter.policy",),
        ),
        migrations.CreateModel(
            name="Target",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("unit", models.CharField(max_length=255)),
                ("host", models.CharField(max_length=255)),
                ("username", models.CharField(max_length=255)),
                ("last_applied", models.JSONField(default=dict)),
            ],
            options={
                "verbose_name_plural": "Targets",
                "constraints": [
                    models.UniqueConstraint(
                        fields=("unit", "host", "username"), name="unique_target"
                    )
                ],
            },
        ),
        migrations.CreateModel(
            name="Violation",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_base_status", models.BooleanField(default=False, editable=False)),
                ("expiration", models.DateTimeField(null=True)),
                ("timestamp", models.DateTimeField(auto_now_add=True)),
                ("offense_count", models.IntegerField(default=1, null=True)),
                (
                    "policy",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="arbiter.policy"
                    ),
                ),
                (
                    "target",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to="arbiter.target"
                    ),
                ),
            ],
        ),
    ]
